"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Analyzer = undefined;

var _jsdom = require("./jsdom.js");

class Analyzer {
  constructor() {
    this.handlers = {};
  }

  static defaultHandleToken(suffix) {
    return function (context) {
      var element = _jsdom.document.createElement("span");
      element.className = context.options.classPrefix + suffix;
      element.appendChild(context.createTextNode(context.tokens[context.index]));
      context.addNode(element);
      return true;
    };
  }

  handleToken(context) {
    return Analyzer.defaultHandleToken(context.tokens[context.index].name)(context);
  }
}
exports.Analyzer = Analyzer;