"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
// sunlight-x: Intelligent Syntax Highlighting, Modernized
// Copyright 2017 Leung Wing-chung. All rights reserved.
// Use of this source code is governed by a Apache License Version 2.0, that can
// be found in the LICENSE file.

var name = exports.name = "diff";

var doNotParse = exports.doNotParse = /(?!x)x/;

var scopes = exports.scopes = {
  header: [["---", "\n", [], true], ["+++", "\n", [], true], ["***", "\n", [], true]],
  added: [["+", "\n", [], true]],
  removed: [["-", "\n", [], true]],
  modified: [["!", "\n", [], true]],
  unchanged: [[" ", "\n", [], true]],
  rangeInfo: [["@@", "\n", [], true]],
  mergeHeader: [["Index:", "\n", [], true], ["=", "\n", [], true]]
};

var customTokens = exports.customTokens = {
  noNewLine: {
    values: ["\\ No newline at end of file"],
    boundary: "\\b"
  }
};