"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.warnInvalidValue = warnInvalidValue;
exports.error = error;
exports.errorInvalidValue = errorInvalidValue;
// sunlight-x: Intelligent Syntax Highlighting, Modernized
// Copyright 2017 Leung Wing-chung. All rights reserved.
// Use of this source code is governed by a Apache License Version 2.0, that can
// be found in the LICENSE file.

var logger = exports.logger = console;

/**
 * Log to warn about invalid values.
 * @param {string} message The message to log.
 */
function warnInvalidValue(message) {
  for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }

  logger.warn(`Sunlight-X: ${message} Given value(s): `, ...args);
}

/**
 * Log to warn about invalid values.
 * @param {string} message The message to log.
 */
function error(message) {
  logger.warn(`Sunlight-X: ${message}`);
}

/**
 * Log to warn about invalid values.
 * @param {string} message The message to log.
 */
function errorInvalidValue(message) {
  for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
    args[_key2 - 1] = arguments[_key2];
  }

  logger.warn(`Sunlight-X: ${message} Given value(s): `, ...args);
}