"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
// sunlight-x: Intelligent Syntax Highlighting, Modernized
// Copyright 2017 Leung Wing-chung. All rights reserved.
// Use of this source code is governed by a Apache License Version 2.0, that can
// be found in the LICENSE file.

// A storage of string
class UserDefinedNameStore {
  constructor() {
    this._store = new Map();
  }

  addName(name, language) {
    var subStore = this._store.get(language);
    if (!subStore) {
      var set = new Set();
      set.add(name);
      this._store.set(language, set);
    } else {
      subStore.add(name);
    }
  }

  hasName(name, language) {
    var subStore = this._store.get(language);
    return !!subStore && subStore.has(name);
  }
}
exports.UserDefinedNameStore = UserDefinedNameStore;